package org.openxma.dsl.platform.collections;

import java.lang.reflect.Array;
import java.util.Collection;

import org.springframework.util.CollectionUtils;

/**
 * Code copied from http://www.javaspecialists.eu/archive/Issue133.html to ensure type integrity with none-generified
 * collections at the time of instantiation.
 */
public class CollectionUtils2 extends CollectionUtils {
    @SuppressWarnings("unchecked")
    public static <T> Collection<T> castTo(Class<T> dest, Collection<?> objects) {
        try {
            objects.toArray((T[]) Array.newInstance(dest, objects.size()));
        } catch (ArrayStoreException ase) {
            throw new ClassCastException(ase.getMessage());
        }
        return (Collection<T>) objects;
    }
}
