/*******************************************************************************
 * Copyright (c) 2010 s IT Solutions AT Spardat GmbH .
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     s IT Solutions AT Spardat GmbH - initial API and implementation
 *******************************************************************************/
package org.openxma.dsl.platform.query.impl;

import org.openxma.dsl.platform.query.Expression;
import org.openxma.dsl.platform.query.ExpressionOperator;

/**
 * An operator expression with two operands.
 */
public abstract class BinaryExpression extends Expression {
    private static final long serialVersionUID = 1L;

    private Expression left;

    private ExpressionOperator operator;

    private Expression right;

    public Expression getLeft() {
        return left;
    }

    public ExpressionOperator getOperator() {
        return operator;
    }

    public Expression getRight() {
        return right;
    }

    public BinaryExpression(Expression left, ExpressionOperator operator, Expression right) {
        super();
        this.parent = left.getParent();
        this.left = left;
        this.operator = operator;
        this.right = right;
        this.left.setParent(this);
        this.right.setParent(this);
    }

}
