package org.openxma.dsl.platform.service.impl;

import java.util.Map;
import java.util.WeakHashMap;

import org.openxma.dsl.platform.dao.EntityFactoryRegistry;
import org.openxma.dsl.platform.service.MapperContext;

public class SimpleMapperContext implements MapperContext {
	private EntityFactoryRegistry entityFactoryRegistry;
	private Map context;

	public SimpleMapperContext(EntityFactoryRegistry entityFactoryRegistry) {
		this(entityFactoryRegistry, new WeakHashMap());
	}

	public SimpleMapperContext(EntityFactoryRegistry entityFactoryRegistry, Map context) {
		this.entityFactoryRegistry = entityFactoryRegistry;
		this.context = context;
	}

	public EntityFactoryRegistry getEntityFactoryRegistry() {
		return entityFactoryRegistry;
	}

	public Map getStateMap() {
		return getContext();
	}

	public Map getContext() {
		return context;

	}
}
