/*
 * @(#) $Id:  $
 *
 * Copyright 2009/2010 by sIT Solutions,
 * A-1110 Wien, Geiselbergstr.21-25.
 * All rights reserved.
 *
 */
package org.openxma.dsl.platform.util;

import java.util.Arrays;

public class ByteArrayContainer {

    private final byte[] byteArr;

    public ByteArrayContainer(byte[] byteArr) {
        this.byteArr = byteArr;
    }

    public byte[] getData() {
        return byteArr;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + Arrays.hashCode(byteArr);
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        ByteArrayContainer other = (ByteArrayContainer) obj;
        if (!Arrays.equals(byteArr, other.byteArr)) {
            return false;
        }
        return true;
    }
}
