package org.openxma.dsl.platform.valueobject;


public class ValueObjectDouble extends ValueObjectComparable<Double> {

    private static final long serialVersionUID = 1L;

    public ValueObjectDouble(Double value) {
        super(value);
    }

    public static ValueObjectDouble newOrNull(Double value) {
        if (value != null) {
            return new ValueObjectDouble(value);
        }
        return null;
    }

    public static ValueObjectDouble newOrNull(String value) {
        if (value != null && value.length() > 0) {
            return new ValueObjectDouble(Double.valueOf(value));
        }
        return null;
    }

}
