package org.openxma.dsl.platform.xma.client.mdl;

import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
import org.openxma.dsl.platform.xma.client.browse.BrowseMode;
import org.openxma.dsl.platform.xma.client.browse.BrowseableUIDelegateClient;

import at.spardat.xma.mdl.ModelChangeEvent;
import at.spardat.xma.mdl.list.ListUIDelegateClient;
import at.spardat.xma.mdl.list.ListWMClient;
import at.spardat.xma.widgets.DatePicker;

public class ListUIDelegateClientDsl extends ListUIDelegateClient implements BrowseableUIDelegateClient {

    Control browseControl;
    Control editControl;

    public ListUIDelegateClientDsl(ListWMClient wModel) {
        super(wModel);

    }

    public void attachUI(Object control, Object label) {
        super.attachUI(control, label);
        if (control instanceof Control) {
            if (((Control) control).getParent() instanceof DatePicker) {
                editControl = ((Control)control).getParent();
            } else {
                editControl = (Control)control;
            }
        }
    }

    public void detachUI() {
        super.detachUI();
        editControl = null;
    }

    public void attachBrowseControl(Control control) {
        browseControl = control;
    }

    public void detachBrowseControl() {
        browseControl = null;
    }

    public Control getEditControl() {
        return editControl;
    }

    @Override
    public void setEditable(boolean what) {
        if (isEditable() != what) {
            if (editControl != null && browseControl != null)  {
                editControl.setVisible(what);
                browseControl.setVisible(!what);
                editControl.getParent().layout();
            }
        }
        // TODO: check whether this can be moved into the condition above
        super.setEditable(what);
    }

    public void handleModelChangeEvent (ModelChangeEvent event) {
        super.handleModelChangeEvent(event);
        updateBrowseControl();
    }

    public void handleUIEvent (Object event, int type) {
        super.handleUIEvent(event, type);
        if (event instanceof FocusEvent == false) {
            updateBrowseControl();
        }
    }

    protected void updateBrowseControl() {
        if (browseControl == null) {
            return;
        }
        String text = null;
        if (editControl instanceof Combo) {
            text =((Combo)editControl).getText();
        }
        BrowseMode.updateBrowseControl(browseControl,text);
    }

}
